__doc__ = """Z Photo Slides by JeanFranois Roche (jfroche@jfroche.be)"""

__version__='$Revision: 1.4 $'[11:-2]
VERSION = '0.6'
DATE = '16/11/02'

from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import HTML
from Globals import package_home
from Globals import MessageDialog # provid
#from Globals import Persistent    # makes an object stick in the ZODB
from OFS.Folder import Folder
from OFS.Image	import Image
#from AccessControl import ClassSecurityInfo
from AccessControl.Role import RoleManager
from AccessControl import getSecurityManager
from AccessControl import User, Unauthorized
import AccessControl
from Persistence import Persistent


import OFS.SimpleItem
import Acquisition
import AccessControl.Role
import traceback
import os, sys
import math
import time
import random
import string
import shutil
import comment
import layout
import message_dialog

#from Products.PageTemplates import ZopePageTemplate
from Products.LocalFS import LocalFS
#from Products.LocalFS.LocalDirectory import defaultDocument
#import Products.LocalFS
from Products.PythonScripts import PythonScript

from IMG_start import *
from image_modif import Image_modif
from IMG_fileobj import FileObj

def upload_file(path,_prefix=None):
        if _prefix is None: _prefix=SOFTWARE_HOME
        elif type(_prefix) is not type(''):
            _prefix=package_home(_prefix)
        path = os.path.join(_prefix, path)

        file=open(path, 'rb')
        data=file.read()
        file.close()
        return data

manage_addZPhotoSlidesForm = HTMLFile('dtml/ZPhotoSlidesAdd', globals())

MessageDialog2 = HTML("""
<HTML>
<HEAD>
<TITLE><dtml-var title></TITLE>
<meta http-equiv="no-cache">
<link rel="stylesheet" href="<dtml-var URL1>/css/<dtml-var actual_css>" type="text/css" />
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<FORM ACTION="<dtml-var action>" METHOD="GET" <dtml-if target>TARGET="<dtml-var target>"</dtml-if>>
 <input type="hidden" name="<dtml-var id>" value="<dtml-var id_content>">
  <CENTER><B><h3><dtml-var title>!</h3></B></CENTER>
  <dtml-if hidden_field>
    <dtml-var hidden_field>
  </dtml-if>
<TABLE BORDER="0" WIDTH="50%" align="center" CELLPADDING="10">
  <tr>
  <TD VALIGN="TOP">
  <BR><BR>
  <CENTER>
  <dtml-if message2>
     <dtml-var message2>
  </dtml-if>
  <dtml-var message1>

  </CENTER>
  </TD>
</TR>
</table>
<br>
  <CENTER>
  <INPUT TYPE="SUBMIT" VALUE="   Ok   ">
  </CENTER>
</FORM>
<br>
</BODY></HTML>""", target='', action='manage_main', title='Changed',id='id',id_content='',URL1='')


def manage_addZPhotoSlides(self, id,photo_folder,thumb_prefix,scale,upload,double_name=1,remove=0,title='',recursive=0,REQUEST=None):
    """Add a ZPhotoSlides to a folder."""
    upload = REQUEST.upload 
    # create localFS
    img = LocalFS.LocalFS('img','Local Images',photo_folder,username=None,password=None)
    for tmpdir in ('/tmp','c:\windows\Temp','c:\\'):
    	  	if os.path.isdir(tmpdir): break
    os.chdir(tmpdir)
    if(not os.path.isdir(os.path.join(tmpdir,'thumb'))): os.mkdir('thumb')
    tmpdir = os.path.join(tmpdir,'thumb')
    tmpwork = LocalFS.LocalFS('tmp','Local Temporary Folder',tmpdir,username=None,password=None)
    self._setObject(id, ZPhotoSlides(id,img,tmpwork,tmpdir,thumb_prefix,title))
    ZPS = self._getOb(id)
    ZPS._setObject('img', img)
    ZPS._setObject('tmp', tmpwork)
    # upload thumbnails
    
    ZPS.ask_4_thumbnails(prefix=thumb_prefix,scale=scale,upload=upload,recursive=recursive,remove=0,double_name=double_name,REQUEST=None)
    ZPS.get_nbr_non_hidden_thumb()
    ZPS.thumbnails.amount_photo = ZPS.get_thumb_amount()
    ZPS._setObject('get_all_css', PythonScript.PythonScript('get_all_css'))
    ZPS.get_all_css.write(upload_file('get_all_css.py',globals()))
    
    ZPS._setObject('comment_for_manage', PythonScript.PythonScript('comment_for_manage'))
    ZPS.comment_for_manage.write(upload_file('comment_for_manage.py',globals()))
    
    ZPS._setObject('batch_slides', PythonScript.PythonScript('batch_slides'))
    ZPS.batch_slides.write(upload_file('batch_slides.py',globals()))

    ZPS._setObject('give_all_images',PythonScript.PythonScript('give_all_images'))
    ZPS.give_all_images.write(upload_file('give_all_images.py',globals()))
		   
    ZPS._setObject('slide_show', PythonScript.PythonScript('slide_show'))
    ZPS.slide_show.write(upload_file('slide_show.py',globals()))

    ZPS._setObject('view_photo', PythonScript.PythonScript('view_photo'))
    ZPS.view_photo.ZPythonScript_edit('id', '')
    ZPS.view_photo.write(upload_file('view_photo.py',globals()))

    ZPS._setObject('getcomment', PythonScript.PythonScript('getcomment'))
    ZPS.getcomment.ZPythonScript_edit('id', '')
    ZPS.getcomment.write(upload_file('getcomment.py',globals()))
    ZPS.list_comment = comment.comments()
                
    ZPS._setObject('index_html',PythonScript.PythonScript('index_html'))
    ZPS.index_html.ZPythonScript_edit('slide=0', '')
    ZPS.index_html.write(upload_file('new_index.py',globals()))

    ZPS._setObject('viewable_images', PythonScript.PythonScript('viewable_images'))
    ZPS.viewable_images.write(upload_file('viewable_images.py',globals()))
    ZPS.new_permission()


    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


class ZPhotoSlides(
    Folder,
  #  ZopePageTemplate,
    OFS.SimpleItem.Item,   # A simple Principia object. Not Folderish.
    Persistent,            # Make us persistent. Yaah!
    Acquisition.Implicit,  # Uh, whatever.
    AccessControl.Role.RoleManager # Security manager.
    ):
    "ZPhotoSlides 0.5"
    access=AccessControl.getSecurityManager()
 
    security = AccessControl.ClassSecurityInfo()
    meta_type = 'ZPhotoSlides' # what do people think they're adding?

    manage_options = ( # what management options are there?
#	               {'label': 'Contents',       'action': 'manage_main'},
	               {'label': 'Properties',       'action': 'manage_props'},
		       {'label': 'View',       'action': 'index_html'}, # defaults to index_html
		       {'label': 'Edit layout', 'action': 'user_layout'},
                       {'label': 'List all files & Edit Photo', 'action': 'list_files'},
                       {'label': 'Make thumbnails', 'action': 'make_thumb'},
		       {'label': 'Manage thumbnails', 'action': 'change_title'},
		       {'label': 'Manage comments','action': 'manage_comment'},
	               {'label': 'Security',   'action': 'manage_access'},
		       {'label': 'About this product',   'action': 'about'}
		     )

    __ac_permissions__=( # what permissions make sense for us?
		         ('View management screens', ('manage_tabs','manage_main')),
			 ('Change permissions',      ('manage_access',)           ),
		         ('Change ZPhotoSlides'     ,     ('manage_edit',)             ),
#			 ('Upload local files' , ('manage_main',)		),
    #                     ('Manage photos' ,  ('manage_main',)      ),
#			 ('View ZPhotoSlides',       ('',)                        ),
		       )

#    manage_main = HTMLFile('dtml/ZPhotoSlidesEdit', globals())
    list_files = HTMLFile('dtml/List_files',globals())
    manage_props = HTMLFile('dtml/ZPhotoSlidesEdit', globals()) # Management Interface
    make_thumb = HTMLFile('dtml/make_thumb',globals()) # form for making the thumb
    edit_image = HTMLFile('dtml/edit_photo',globals())
    change_title = HTMLFile('dtml/list_title',globals())
    add_comment = HTMLFile('dtml/add_comment',globals())
    edit_comment = HTMLFile('dtml/edit_comment',globals())
    choose_color = HTMLFile('dtml/choose_color',globals())
    about = HTMLFile('dtml/about',globals())
    define_css = HTMLFile('dtml/define_css',globals())
    user_layout = HTMLFile('dtml/user_layout',globals())
    manage_comment = HTMLFile('dtml/manage_comment',globals())
    css_info = HTMLFile('dtml/stylesheet_demo.css',globals())
    #slide_show = HTMLFile('dtml/slide_show',globals())
     
    security.declarePublic('index_html','batch_slides','view_photo','getcomment','viewable_images')
    security.declareProtected('View management screens','img','get_all_css','about','define_css',
			      'user_layout','list_files','change_title','edit_image','make_thumb',
			      'manage_main','manage_props','edit_comment','comment_for_manage','give_all_images')

    def __init__(self, id,img,tmpwork,tmpdir,thumb_prefix,title=''):
        """initialise a new instance of ZPhotoSlides"""
        self.id = id
        self.version = VERSION
        self.update_date = DATE
        self.title = title
        self.thumb_prefix = thumb_prefix
        self.image_folder = img
        self.color_fonts = 'blue'
        self.tmp_dir = tmpdir
        self.layout_list = layout.give_list()
        self.img_doc = img.defaultDocument()
        self.manage_addFolder('thumbnails', 'Thumbnails', createPublic=0, createUserF=0, REQUEST=None)
        self.manage_addFolder('css', 'Thumbnails', createPublic=0, createUserF=0, REQUEST=None)
	self.css._setProperty('amount_css',1,'int')
	self.css.manage_addDTMLMethod('stylesheet_base_css', 'Main ZPhotoSlides Stylesheet', upload_file('dtml/stylesheet.css', globals()), REQUEST=None)
	self.actual_css = 'stylesheet_base_css'
        self.thumbnails._setProperty('amount_photo',self.get_thumb_amount(),'int')
#	self.manage_addFolder('comments', 'Comments', createPublic=0, createUserF=0, REQUEST=None)
	self.non_hidden_pic = 0
	self.list_non_hidden_pic = []
	self.rows = 3
	self.column = 3
	self.zphoto_header= ''
	self.list_photo = {}
	self.info_photo = {}
	self.zphoto_footer= ''
	self.keywords = ''
	self.description = ''
	self.show_comment = 1
	self.show_automatic_slide_show = 1
	self.show_viewed = 1
	imagepath=os.path.join(package_home(globals()),os.path.join('dtml','colorwheel.jpg'))
	file = open(imagepath,'rb')
	data = file.read()
	file.close()
        type = OFS.Image.getImageInfo(data)
	self.manage_addImage('colorwheel.jpg',data,content_type=type[0])
	
    def new_permission(self):
	"define new permission"
	self.manage_permission('Upload local files',('Manager','Owner'),acquire=0)
#	self.thumbnails.manage_permission('View',('Manager'),acquire=0)
	
    security.declarePublic('use_comment')
    def use_comment(self,id_photo,name,commt,place,email,REQUEST):
	"coooool"
	times = time.strftime('%H:%M:%S %d-%m-%Y', time.localtime()) 
	self.list_comment.add_new(id_photo,commt,name,place,times,REQUEST.REMOTE_ADDR,email)
	url = REQUEST.HTTP_REFERER
	url = url.split('?photo=')[1]
	list_param = {}
	list_param['id'] = url
	url_action = REQUEST.URL1
	url_action = url_action + '/view_photo'
	
	if REQUEST is not None:
            return MessageDialog2(
                title = 'Comment added',
                message1 = "Comment added for %s." % id_photo[3:],
                action = url_action,
		id = 'id',
		id_content = url,
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
                )

    security.declarePublic('use_comment')    
    def get_comment(self,id_photo):
#	"cooooool"
	liste_dict = [] 
	for elem in self.list_comment:
#	    print elem.id
#	    print id
	    if(elem.id==id_photo):
#		    print 'poueeeeeeeeeeeeeet'
		    dict= {}
		    dict['comment'] =elem.commt
		    dict['user'] = elem.user
		    dict['place'] = elem.place
		    dict['date'] = elem.date
		    dict['ip'] = elem.ip
		    dict['email'] = elem.email
		    liste_dict.append(dict)	
	return liste_dict

    security.declareProtected('View management screens','delete_comment')
    def delete_comment(self,photo_id,comment_date,REQUEST):
	"cool"
	for comment in self.list_comment:
		if(comment.id==photo_id and comment.date==comment_date):
			self.list_comment.remove(comment)
			break
	if REQUEST is not None:
            return MessageDialog2(
                title = 'Comment deleted',
                message1 = "Comment deleted for %s." % photo_id,
                action = 'manage_comment',
		id = 'id',
		id_content = '',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
                )
        
    def modify_comment(self,photo_id,old_date,date,name,email,place,commt,REQUEST):
	"cool"
	for comment in self.list_comment:
		if(comment.id==photo_id and comment.date==old_date):
			comment.date = date
			comment.user = name
			comment.email = email
			comment.place = place
			comment.commt = commt
			break
		
	if REQUEST is not None:
            return MessageDialog2(
                title = 'Comment Modified',
                message1 = "Comment Modified for %s." % photo_id,
                action = 'manage_comment',
		id = 'id',
		id_content = '',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
                )
		    
    def get_nbr_non_hidden_thumb(self):
#	"cool"
	images = self.thumbnails.objectValues('Image')
	nbr= len(images)
	list_thumb = []
	for img in images:
		if(img.getviewit=='0'):
			nbr = nbr - 1
		else:
			list_thumb.append(img)
	self.non_hidden_pic = nbr
	self.list_non_hidden_pic = list_thumb
	self.list_non_hidden_pic.sort(lambda x, y: cmp(x.position, y.position))
	return None

    security.declareProtected('View management screens','add_new_css')
    def add_new_css(self,REQUEST):
	"Add a new CSS file in css folder"
	title=REQUEST.title
	file = REQUEST.file
	print file
	id = 'css' + str(self.css.amount_css)
	self.css.manage_addDTMLMethod(id, title, file, REQUEST=None)
	self.css.amount_css = self.css.amount_css + 1
	self.actual_css = id
	return MessageDialog2(
		title = 'CSS Added',
		message1 = 'Your CSS file has been added !',
		action = 'user_layout',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
		)
    security.declareProtected('View management screens','use_uploaded_css')
    def use_uploaded_css(self,REQUEST):
	"Use a css which is in folder css"
	choosed = REQUEST.uploaded_css
	self.actual_css = choosed
	return MessageDialog2(
		title = 'CSS Choosed',
		message1 = 'The Css file you choose is now used to define the layout !',
		action = 'user_layout',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
		)
    security.declareProtected('View management screens','change_main_css')
    def change_main_css(self,REQUEST):
	"Change the main css tag for the Main ZPhotoSlides Stylesheet"
	dict = REQUEST.form
	for elem in dict.keys():
	   dic1,dic2 = string.split(elem,'__')
	   self.layout_list[dic1][dic2] = dict[elem]
	self.actual_css = 'stylesheet_base_css'
	return MessageDialog2(
		title = 'Modifications saved',
		message1 = 'Modifications saved for Main ZPhotoSlides Stylesheet!',
		action = 'user_layout',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
		)

    def give_header_4_robots(self):
	"give the header for the robots"
	return """
<meta name="KEYWORDS" content="%s" />
<meta name="DESCRIPTION" content="%s" />
<meta name="resource-type" content="document" />
<meta name="ROBOTS" content="INDEX,FOLLOW" />
<meta http-equiv="expires" content="0" />
<meta name="author" content="ZPhotoSlides" />
<meta name="copyright" content="ZPhotoSlides %s" />
<meta name="revisit-after" content="1 days" />
<meta name="rating" content="General" />""" % (self.keywords,self.description,self.version)
    
    security.declareProtected('View management screens','new_header_footer')
    def new_header_footer(self,REQUEST):
	"Change the standard_html_header and footer"
	self.zphoto_header = REQUEST.header
	self.zphoto_footer = REQUEST.footer
	if(REQUEST.header != '' and REQUEST.footer != ''):
                msg1 = """You use yet the standard html footer and header. To use the css files again
                make the standard html footer and header <u><i>EMPTY</i></u> in the layout formular!"""
                title_1 = "Using standard html header and footer"
        else:
		msg1 = """You use yet the CSS file."""
		title_1 = "Using CSS file"
	return MessageDialog2(
		title = title_1,
		message1 = msg1,
		action = 'user_layout',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
	)

    def get_list_photo_4_slideshow(self,REQUEST,full):
	"get the list of photos for the Javascript of the slideshow"
	list_string = ''
	cpt = 1
	for elem in self.list_non_hidden_pic:
		dict = {}
		if(full=='1'): # si full -> access au fichier en full
			url = REQUEST.URL1 + '/img/' + elem.access
			string1 = 'photo_urls[%d] = "%s";' % (cpt,url)
			string2 = 'photo_captions[%d] = "%s";' % (cpt,elem.title_or_id())
			list_string = list_string + '\n' + string1 + '\n' + string2 + '\n'
		else:
			url_small = REQUEST.URL1 + '/thumbnails/' + elem.getId()
			string3 = 'photo_urls_small[%d] = "%s";' % (cpt,url_small)
			string2 = 'photo_captions[%d] = "%s";' % (cpt,elem.title_or_id())
			list_string = list_string + '\n' + string2 + '\n' + string3
                
		cpt = cpt + 1
	return list_string[1:]
	    
    def amount_photos(self):
	return len(self.list_non_hidden_pic)
	
    security.declarePublic('photo_visited')   
    def photo_visited(self,thumb_id):
	"""increase the number of visit of a photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	#print thumb_pic
        #thumb_pic._setProperty('viewed',int(thumb_pic.viewed) + 1)
	thumb_pic.viewed = int(thumb_pic.viewed) + 1
        return thumb_pic

    def getRandom(self):
	return random.randint(0,100)

    security.declarePublic('img_allow_show')
    def img_allow_show(self,img_name):
#	"return 1 if the image can be show"
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==img_name):
			return int(img.getviewit)
	return 0

    security.declarePublic('getSlide')
    def getSlide(self,thumb_id):
	"""Give the number of the slide where is the photo"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos= int(thumb_pic.position)
	tmp = (pos)/(self.rows*self.column)
	return tmp

    security.declarePublic('photo_hasPrev')
    def photo_hasPrev(self,thumb_id):
	"""Give the previous photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = int(thumb_pic.position)
	min = 99999999
	min_photo = ''
#	for img in self.thumbnails.objectValues('Image'):
	for img in self.list_non_hidden_pic:
	    if(img.getId()!=thumb_id and pos > img.position and pos-int(img.position)<min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    security.declarePublic('photo_hasNext')
    def photo_hasNext(self,thumb_id):
	"""Give the next photo of the list"""
	thumb_pic = ''
	for img in self.thumbnails.objectValues('Image'):
	    if(img.getId()==thumb_id):
		thumb_pic = img
	pos = int(thumb_pic.position)
	min = 999999999
	min_photo = ''
#	for img in self.thumbnails.objectValues('Image'):
	for img in self.list_non_hidden_pic:
	    if(img.getId()!=thumb_id and pos < img.position and int(img.position)-pos < min):
		min = pos-int(img.position)
		min_photo = img.getId()
	if(min_photo == ''):
		return ''
	else:
		return min_photo

    def manage_edit(self, title,keywords,description,show_comment,rows,column,photo_folder,show_automatic_slide_show,show_viewed, REQUEST=None):
	"""does this really need a doc string?"""
	self.title = title
	self.show_automatic_slide_show = int(show_automatic_slide_show)
	self.keywords = 'ZPhotoSlides,' + keywords
	self.description = description
	old_basepath = self.image_folder.basepath
        self.image_folder.basepath = photo_folder
	self.rows = int(rows)
	self.show_viewed = int(show_viewed)
	self.show_comment = int(show_comment)
	print self.show_comment
	self.column = int(column)
	if(old_basepath != photo_folder):
		self.remove_thumbnails()
        if REQUEST is not None:
            return MessageDialog(
                title = 'Edited',
                message = "Properties for %s changed." % self.id,
                action = './manage_props',
                )

    security.declarePrivate('remove_thumbnails')
    def remove_thumbnails(self):
	for img in self.thumbnails.objectValues('Image'):
		self.thumbnails.manage_delObjects(img.getId())

    security.declareProtected('View management screen','delete_thumbnail')
    def delete_thumbnail(self,id,REQUEST):
	"delete a selected thumbnail"
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==id):
			self.thumbnails.manage_delObjects(img.getId())
	return MessageDialog2(
		title = 'Thumbnail %s deleted' % id,
		message1 ='Thumbnails %s deleted successfuly !!!' % (id),
		message2 = '',
		hidden_field = '',
		action = 'change_title',
		id = '',
		id_content = '',
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
	)
	
    
    security.declarePrivate('remove_thumbnails_from_disk')
    def remove_thumbnails_from_disk(self):
	for img in self.tmp.fileValues():
		tmpdir = os.path.join(self.tmp_dir,img.id)
		os.remove(tmpdir)
		    
    security.declareProtected('View management screen','ask_4_thumbnails')
    def ask_4_thumbnails(self,prefix=None,scale=None,upload=None,recursive=None,double_name=None,remove=0,REQUEST=None):
        """Make the thumbnails   from the path"""
	info = ''
	if prefix == None: prefix = REQUEST.prefix
        if scale == None: scale = REQUEST.scale
        if recursive == None: recursive = REQUEST.recursive # -> allow recursive in folder
        if double_name == None: double_name = REQUEST.double_name # able to manage photos with same name in different folder
        if upload == None: upload = REQUEST.upload
        remove = int(remove)
        upload = int(upload)
        if(remove):
		list = self.thumbnails.objectValues()
		for elem in list:
			self.thumbnails.manage_delObjects(elem.getId())
		
	scale = int(scale)
	start_path = self.image_folder.basepath
        try:
		self.list_photo = thumbnails_manage(start_path,self.tmp_dir,recursive,double_name,
						    scale,prefix,self.list_photo)
	#	print 'upload:' + str(upload)
        except:
		print traceback.print_exc()
	          
	result = 'Thumbnails done in folder %s' % self.tmp_dir
        if(upload==1):
	    #print 'uploaded'
	    info = self.upload_thumbnails(prefix)
	    result = result + '<br>Thumbnails uploaded in ZODB'
	    self.remove_thumbnails_from_disk()
	if (info != ''):
		result = result + '<br><center><b><font color="red">Error on files: %s</b></font></center>' %info
        if REQUEST is not None:
            return MessageDialog(
                title = 'Thumbnails',
                message = result,
                action = 'list_files' ,
                )
              
    security.declarePrivate('update_position')
    def update_position(self,new_position,old_position):
	for img in self.thumbnails.objectValues('Image'):
		if(img.position == new_position):
			img.position = old_position
				
    security.declareProtected('View management screen','update_photos_prop')
    def update_photos_prop(self,REQUEST):
        """cooo"""
	list = []
	for elem in REQUEST.items():
		if elem[0].find('stringbidon') != -1:
			list.append(elem)
	list2 = []
	dict = {}
	list3 = []
	for elem in list:
		full = elem[0].split('/')
		id = full[1]
		property = full[2]
		value = elem[1]
		for img in self.thumbnails.objectValues('Image'):
	                if(img.getId()==id):
			   if property == 'removeit':
				if(value == '1'):
 					pos_del = img.position
					self.thumbnails.manage_delObjects(img.getId())
					for img in self.thumbnails.objectValues('Image'):
						if(img.position > pos_del):
#							print 'wuhu!!!!!!'
							img.position = img.position - 1
					list3.append(id)
			   else:
				   if property == 'title':
					if(img.title != value):
						img.title = value
						list3.append(id)
				   if property == 'viewit':
					if(img.getviewit != value):
						img.getviewit = value # property has change
						list3.append(id)
				   if property == 'position':
					old_position = img.position
					new_position = int(value)
					if(img.position != new_position):
						list3.append(id)
						self.update_position(new_position,old_position)
						img.position = new_position
				   list2.append(img)
	string = ''
	for img in list3:
		cpt = 0
		for imgs in list3:
			if(img == imgs):
				cpt = cpt + 1
		if(cpt!=1):
			for cpt in range(cpt-1):
				list3.remove(img)
#	return list3
	for img in list3:
		string = string + ', ' + img
	self.get_nbr_non_hidden_thumb()
	self.thumbnails.amount_photo = self.get_thumb_amount()
	string = string[1:]
	if(list3 != []):
		result = 'Properties of %s have been updated' % string
	else:
		result = 'Seems that you didnt change anything.'
	return MessageDialog(
		title = 'Change Properties',
		message = '%s.' % result,
		action = 'change_title',
		)

    security.declareProtected('View management screen','update_photo_prop')
    def update_photo_prop(self,REQUEST):
        """Update the title of a photo"""
	title = REQUEST.title
	id = REQUEST.id
	new_position = int(REQUEST.position)
	for img in self.thumbnails.objectValues('Image'):
		if(img.getId()==id):
			oldtitle = img.title
			img.title = title
			old_getviewit = img.getviewit
			old_position = img.position
			if(img.position != new_position):
				self.update_position(new_position,old_position)
			img.position = new_position
			img.getviewit = REQUEST.viewit
	if (oldtitle == title and old_getviewit == REQUEST.viewit and old_position == REQUEST.position):
		result = 'Seems that you didnt change anything of %s' % id
	else:
		result = 'Properties of %s has been updated' % id
        # FIX ME !!!!
        
	#return self.change_title(REQUEST=REQUEST)
        return MessageDialog(
                title = 'Change Title',
                message = "%s." % result,
                action = 'change_title' ,
                )

    def get_img_in_thumbnails(self,img_id,list):
	for elem in list:
		if(elem.getId() == img_id):
			return elem
	return None

    def upload_file(self,tmpdir,cpt,img):
	info = ''
	prop_id = 'getviewit'
	prop2_id = 'position'
	prop3_id = 'viewed'
	prop4_id = 'access' # way to access to the file
	prop5_id = 'way_to_access'
	file = open(tmpdir,'rb')
	data = file.read()
	file.close()
	cpt = self.get_thumb_amount()
	type = OFS.Image.getImageInfo(data)
	self.thumbnails.manage_addImage(img.id,data,content_type=type[0])
	imag = getattr(self.thumbnails,img.id)
	imag._setProperty(prop2_id.strip(),cpt,'int')
	cpt = cpt + 1
	imag._setProperty(prop5_id.strip(),'filesystem')
	imag._setProperty(prop4_id.strip(),self.list_photo[imag.getId()])
	imag._setProperty(prop_id.strip(), '1')
	imag._setProperty(prop3_id.strip(), '0')
	return cpt
	
    security.declareProtected('View management screen','upload_thumbnails')
    def upload_thumbnails(self,prefix=None):
	"""Upload the thumbnails into the ZODB"""
	info = ''
	cpt = 0 
	if(prefix==None):
		prefix = self.thumb_prefix
	for img in self.tmp.fileValues():
#		print img.getId()
		if(img.id[:len(prefix)]==prefix and img.id[-3:]!='bak'):
			 # take thumbnails and bak files!
			 tmpdir = os.path.join(self.tmp_dir,img.id)
			 start_path = os.path.join(self.image_folder.basepath,img.id)
			 list = self.thumbnails.objectValues()

			 image = self.get_img_in_thumbnails(img.id,list)

			 if(image == None):
			#	print img.id
				cpt = self.upload_file(tmpdir,cpt,img)

			 elif(img.get_size() != image.getSize()):
			#	print 'deleted ' + img.getId()
				self.thumbnails.manage_delObjects(img.getId())
				cpt = self.upload_file(tmpdir,cpt,img)

#	self.thumbnails.amount_photo = self.get_thumb_amount()

    def get_thumb_amount(self):
	#print len(self.thumbnails.objectValues('Image'))
	return len(self.thumbnails.objectValues('Image'))

    def back_from_form(self,REQUEST):
	text = ''
	for elem in REQUEST.form.keys():
		value = REQUEST.form[elem]
		if(value==''):
		   value='0'
		if(elem!='file'):
		   text = text + '<input type="hidden" name="%s" value="%s">' % (elem,value)
	return text
	
    def view_preview(self,REQUEST):
	"""View the preview of an image"""
	img = self.image_modif(REQUEST,1)
	image = REQUEST.file
	location = os.path.join(self.tmp_dir,img.imgname)
	img.save_to(location)
	hidden_part = self.back_from_form(REQUEST)
	msg2 = ''
	print msg2
	if(hasattr(REQUEST,'show_both') and REQUEST.show_both=='on'):
		msg2 = '<table><tr><td class="boxborder"><center><h4>Before modification:</h4></center><br> <img src="%s/img/%s?%d"></td>' % (REQUEST.URL1+'',image,random.randint(0,100))
        else:
                msg2 = ''
	return MessageDialog2(
		        title = 'Preview modification of %s' % image,
			message1 ='<td class="boxborder"><center><h4>After modification: </h4></center><br><center><img src="%s/tmp/%s?%d"></center></td></tr></table>' % (REQUEST.URL1+'',img.imgname,random.randint(0,100)),
			message2 = msg2,
			hidden_field = hidden_part,
	  		action = 'edit_image',
			id = 'file',
			id_content = image,
			URL1 = REQUEST.URL1,
			actual_css = self.actual_css
			)
	
	
    security.declareProtected('View management screen','image_modif')
    def image_modif(self,REQUEST,preview=0):
        """Modify an image """
	image = REQUEST.file
        angle = REQUEST.angle
	path = self.image_folder.basepath
	abspath = path + '/' + image
	img = Image_modif(abspath)
        img.make_backup()
	modif = 0
	if(hasattr(REQUEST,'rotate') and REQUEST.rotate=='on'):	
		img.getrotate(angle)
		modif = 1
	if(hasattr(REQUEST,'grayscale') and REQUEST.grayscale=='on'):
		img.remove_color()
		modif = 1
	if(hasattr(REQUEST,'change_size') and REQUEST.change_size=='on'):
		modif = 1
		width = float(REQUEST.width)
		height = float(REQUEST.height)
		if(hasattr(REQUEST,'keep_ratio') and REQUEST.keep_ratio=='on'):
			oldheight = float(REQUEST.old_height)
			oldwidth = float(REQUEST.old_width)
			ratio = oldwidth/oldheight
			if(oldheight!=height and oldwidth==width): # height is modified
				width = ratio * height
			elif(oldheight==height and oldwidth!=width): # width is modified
			#	print ratio
			#	print ' coool '
				height = width/ratio
			#	print height
			elif(oldheight!=height and oldwidth!=width):
				width = ratio * height		
			img.resize_image(int(height),int(width),ratio)
		else:
			img.resize_image(height,width,0)
			
	if(hasattr(REQUEST,'change_color') and REQUEST.change_color=='on'):
		modif = 1
		img.change_Color(int(REQUEST.color)/100)
		
	if(hasattr(REQUEST,'change_brightness') and REQUEST.change_brightness=='on'):
		modif = 1
		img.change_Brightness(int(REQUEST.brightness)/100.0)
		
	if(hasattr(REQUEST,'change_contrast') and REQUEST.change_contrast=='on'):
		modif = 1
		img.change_contrast(int(REQUEST.contrast)/100.0)
		
	if(hasattr(REQUEST,'change_sharpness') and REQUEST.change_sharpness=='on'):
		modif = 1
		img.change_Sharpness(int(REQUEST.sharpness)/100.0)
		
	if(hasattr(REQUEST,'filter_blur') and REQUEST.filter_blur=='on'):
		modif = 1
		img.filter_blur()
		
	if(hasattr(REQUEST,'filter_contour') and REQUEST.filter_contour=='on'):
		modif = 1
	        img.filter_contour()
	        
	if(hasattr(REQUEST,'filter_detail') and REQUEST.filter_detail=='on'):
		modif = 1
		img.filter_detail()
		
	if(hasattr(REQUEST,'filter_enhance') and REQUEST.filter_enhance=='on'):
		modif = 1
		img.filter_enhance()
		
	if(hasattr(REQUEST,'filter_emboss') and REQUEST.filter_emboss=='on'):
		modif = 1
		img.filter_emboss()
		
	if(hasattr(REQUEST,'filter_find_edges') and REQUEST.filter_find_edges=='on'):
		modif = 1
		img.filter_find_edges()
		
	if(hasattr(REQUEST,'filter_smooth') and REQUEST.filter_smooth=='on'):
		modif = 1
		img.filter_smooth()
		
	if(hasattr(REQUEST,'filter_sharpen') and REQUEST.filter_sharpen=='on'):
		modif = 1
		img.filter_sharpen()
		
	if(hasattr(REQUEST,'equalize') and REQUEST.equalize=='on'):
		modif = 1
		img.equalize()
		
	if(hasattr(REQUEST,'auto_contrast') and REQUEST.auto_contrast=='on'):
		modif = 1
		img.auto_contrast()
		
	if(hasattr(REQUEST,'add_border') and REQUEST.add_border=='on'):
		modif = 1
		borderadd = int(REQUEST.border_to_add)
		fill_border = REQUEST.fill
		print '123'
		img.add_borders(borderadd,fill_border)
		
	if(hasattr(REQUEST,'crop_image') and REQUEST.crop_image=='on'):
		modif = 1
		border = int(REQUEST.remove_border)
		img.crop_image(border)
		
	if(hasattr(REQUEST,'invert_image') and REQUEST.invert_image=='on'):
		modif = 1
		img.invert_image()
		
	if(hasattr(REQUEST,'transpose_left_right') and REQUEST.transpose_left_right=='on'):
		modif = 1
		img.transpose_left_right()

	if(hasattr(REQUEST,'solarize') and REQUEST.solarize=='on'):
		modif = 1
		img.solarize(REQUEST.threshold)
		
	if(preview==1):
		return img
	if (modif==0):
	        return MessageDialog2(
		        title = 'Image Modification',
			message1 =  'Nothing has to be done on image %s!' % image,
			action = 'edit_image',
			id = 'file',
			id_content = image,
			URL1 = REQUEST.URL1,
			actual_css = self.actual_css
			)
	img.save_modif()
	if REQUEST is not None:
                return MessageDialog2(
                 title = 'Image Modification',
                 message1 = "Modification for %s done." % image,
                 action = 'edit_image' ,
		 id = 'file',
		 id_content = image,
		 URL1 = REQUEST.URL1,
		 actual_css = self.actual_css
                 )
    
    security.declareProtected('View management screen','get_image_info')
    def get_image_info(self,image_name):
	"""Get all the informations about an image"""
	path = self.image_folder.basepath
	abspath = os.path.join(path,image_name)
	print abspath
	img = Image_modif(abspath)
	dict = img.get_info()
	return dict

    security.declareProtected('View management screen','undo_modif')
    def undo_modif(self,REQUEST):
	"""Undo a previous modification of an image"""
	image = REQUEST.file
	bak = image + '.bak'
	path = self.image_folder.basepath
	new = os.path.join(path,image)
	backup = os.path.join(path,bak)
#	print backup
	if os.path.exists(backup):
	#    cmd = 'mv ' + backup + ' ' + new
	#    os.rename(backup,new)
	    shutil.copyfile(backup,new)
	    os.remove(backup)
#            os.popen(cmd)
            return MessageDialog2(
                title = 'Undo',
                message1 = "Undo successfull !",
                action = 'edit_image' ,
		id = 'file',
		id_content = image,
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
                )	
	else:
	    return MessageDialog2(
                title = 'Undo',
                message1 = "Sorry, undo can't be done for this image.",
                action = 'edit_image' ,
		id = 'file',
		id_content = image,
		URL1 = REQUEST.URL1,
		actual_css = self.actual_css
                )
                
    security.declareProtected('View management screen','notthumb')
    def notthumb(self,id):
	self.thumb_prefix_size = len(self.thumb_prefix)
	result = 1
	if(id[:self.thumb_prefix_size]==self.thumb_prefix):
		result = 0
	return result
	
    security.declarePublic('view_slides')
    def view_slides(self,REQUEST=None):
	"""print index_html"""
        try: 
	    return self.script_view(9)
	except:
	    print traceback.print_exc()

